var update= function () { return null;};
var dragObj = null;
function escLua(s) {
    return s.replace(/(['"])/g,"\\$1"); // "'
};

function escJQ(s) {

    return s.replace(/([#;&,.+*~':"!^$[\]()=>|])/g,"\\$1");// "'
};

function ui_UnHide( eThis , expand){
    var li = findParentByTag(eThis, 'LI', 6);
    var ret;
    if(li) {
        if( (typeof(expand) != 'undefined' && expand>0 ) || (li.className == "ui_cl" && ! (typeof(expand) != 'undefined' && expand==0 )) ){
            ret =  li.className != "ui_ex";
            li.className = "ui_ex";
        }else{
            ret =  li.className != "ui_cl";
            li.className = "ui_cl";
        }
    }
    return ret;
}


function crossBtn(e){
    if (!e.which && e.button) {
        if (e.button & 1) e.which = 1
        else if (e.button & 4) e.which = 2
        else if (e.button & 2) e.which = 3
    }
    return  e;
};
function crossXY(e){
    e = e || window.event
    if (e.pageX == null && e.clientX != null ) {
        var html = document.documentElement
        var body = document.body
        e.pageX = e.clientX + (html && html.scrollLeft || body && body.scrollLeft || 0) - (html.clientLeft || 0)
        e.pageY = e.clientY + (html && html.scrollTop || body && body.scrollTop || 0) - (html.clientTop || 0)
    }
    return e;
};

function dragOnMouseDown(e, eThis){
    e = crossBtn(e);
    if (e.which==1) {
        e = crossXY(e);
        var item= findChildByTagClass(document,"div","ui_menu", 20);
        $("body").css("cursor", "move");
        dragObj = {"obj":item,
                   "dragX":true,
                   "dragY":false,
                   "attrXMax":1000,
                   "attrXMin":50,
                   "difX":e.pageX-$(item).width(),
                   "setX":function(item, value){
                       $(item).width(value);
                   },
                   "getX":function(item){
                       return $(item).width();
                   }
                  };
    }
    return false;
};
function dragOnMouseMove(e, eThis){
    if (dragObj != null){
        e = crossBtn(e);
        e = crossXY(e);
        if (dragObj.dragX) {
            var attr = parseInt(dragObj.getX(dragObj.obj));
            var dif = e.pageX - attr;
            var newAttr = attr - dragObj.difX + dif;
            if (newAttr<=dragObj.attrXMax &&
                newAttr>=dragObj.attrXMin){
                dragObj.setX(dragObj.obj, newAttr);
            }
        }
        if (dragObj.dragY) {
            var attr = parseInt(dragObj.getY(dragObj.obj));
            var dif = e.pageY - attr;
            var newAttr = attr - dragObj.difY + dif;
            if (newAttr<=dragObj.attrYMax &&
                newAttr>=dragObj.attrYMin){
                dragObj.setY(dragObj.obj, newAttr);
            }
        }
    }
    return false;
};

function dragOnMouseUp(e, eThis){
    e = crossBtn(e);
    e = crossXY(e);
    if (e.which==1) {
        $("body").css("cursor", "inherit");
        dragObj = null;
    }
    return false;
};

function setContent(eThis) {
    CONTENT = "";
    do {
        eThis = $(eThis).parent().closest("li");
        if(eThis.size()==0)
            break;
        CONTENT=  "\"" + escLua($(eThis).attr('name')) + "\"," + CONTENT;
    }
    while (1);
    CONTENT = "{" + CONTENT + "}";
    update();
};
function genLi(name, className , text) {
    var li = document.createElement("LI");
    $(li).addClass(className);
    $(li).attr('name', name);
    $(li).attr('id', name);
    li.innerHTML = "<table class=\"ui_node\">"+
        "<tbody>"+
        "<tr valign=\"middle\">"+
        "<td>"+
        "<a class=\"ui_sc\" onclick=\" ui_UnHide(this); return false;\" title=\"header=[webBtnExpand] body=[]\">"+
        "<img class=\"bexpand\" src=\"/expand.png\"/>"+
        "</a>"+
        "<a class=\"ui_sch\" onclick=\" ui_UnHide(this); return false;\" title=\"header=[webBtnCollapse] body=[]\">"+
        "<img class=\"bcollapse\" src=\"/collapse.png\"/>"+
        "</a>"+
        "</td>"+
        "<td class=\"ui_param\" width=\"120\" title=\"\">"+
        "<span class=\"ui_dir\">"+
        "<a class=\"ui_name\" onclick=\" setContent(this); return false;\" onkeydown=\"paramKeyDown(event, this)\" href=\"javascript:void(0)\">"+text+"</a>"+
        "</span>"+
        "<input class=\"ui_value\" type=\"hidden\" value=\"sys\" name=\"sys\"/>"+
        "</td>"+
        "<td class=\"ui_value\"> </td>"+
        "<td class=\"ui_itemcontrols\"> </td></tr>"+
        "</tbody>"+
        "</table>"+
        "<div class=\"ui_dir\">"+
        "<div class=\"ui_dircontrol\">"+
        "</div>"+
        "<ul>  </ul>"+
        "</div>";
    return li;
};


function updateMenu(){
};
function updateContent(){
};

function delTun(tun) {
    $("li[name='"+escJQ(tun)+"']").remove();
};
function delTunCh(tun, ch) {
    $($("li[name='"+escJQ(ch)+"']") ,$("li[name='"+escJQ(tun)+"']")).remove();
};
function updTun(tun, state) {
    if (0==$("li[name='"+escJQ(tun)+"']").size()) {
        $("ul.ui_root")[0].appendChild(genLi(tun,"ui_cl","<span class=\"ui_"+state+"\">"+ tun+"</span>"));
        $($("ul.ui_root")[0]).tsort("li",{attr:"name"});
    } else {
        $("li[name='"+escJQ(tun)+"'] span.ui_dead,li[name='"+escJQ(tun)+"'] span.ui_suspended,li[name='"+escJQ(tun)+"'] span.ui_normal").removeClass().addClass("ui_"+state);
    }
};

function updTunCh(tun, index, host, port, peerHost, peerPort, direction) {
    var text = "["+index+"] " + peerHost +":"+  peerPort + " " + direction + " " + host +":"+ port;
    if (0==$("li[name='"+escJQ(index)+"']").size()) {
        $("li[name='"+escJQ(tun)+"'] div.ui_dir ul" )[0].appendChild(genLi(index, "ui_channel", text));
        $($("li[name='"+escJQ(tun)+"'] div.ui_dir ul" )[0]).tsort("li",{attr:"name"});
    }
};

update = function (){
    if(TIMER) {
        clearTimeout(TIMER);
        TIMER=null;
    }
    if (REQUEST) {
        REQUEST.abort();
        REQUEST = null;
    }
    var menu = "{";
    $("li:has(li)").each(function (index, Elem) {
        menu = menu + "['" + escLua($(Elem).attr('name')) + "'] = {";
        var nameLen = $(Elem).attr('name').length;
        $("li", Elem).each(
            function (index, Elem) {
                var id = $(Elem).attr('name');
                menu = menu + "[" + id + "] = {},";
            }
        );
        menu = menu + "},";
    });
    menu = menu + "}";
    $("body div.ui_head img.brefresh").removeClass().addClass("brefreshactive").attr("src","/loading.gif");
    REQUEST = $.post("/",
                     "command=getHTML&subcmd=update&menu="+encodeURIComponent(menu)+"&content="+encodeURIComponent(CONTENT)+"&"+AUTH,
                     function(data) {
                         //alert(data);
                         $("body div.ui_head img.brefreshactive").removeClass().addClass("brefresh").attr("src","/nil.png");
                         REQUEST = null;
                         eval('[function (){' + data + '}][0]')();

                         $("span.locale").html(
                             function(index, text) {
                                 var s = getHelp(text);
                                 s = s.replace(/^uitcp_/,"");
                                 return s;
                             }).removeClass().addClass("located");

                         if(TIMER) {
                             clearTimeout(TIMER);
                             TIMER=null;
                         }
                         TIMER = setTimeout('update()',$("select.ui_period").val()*1000);
                     });
};

function onLoad(){
    update();
};